#include "stdafx.h"
#include "../Lift.h"
#include "Automat.h"
#include "A1.h"
#include "A2.h"
#include "A0.h"

//    
const A0::e0=0;
const A0::e1=1;

///////////////////////////////////////////////////////////////
//   A0

void A0::Step(int e)
{
    switch (y)
    {
        case 0: // C 
            if (e==e0) {
		        DoNested(e,&aA1);
	            DoNested(e,&aA2);
                z1_0();
                z2_0();
                z3_0();
            } else
            if (x2_1()) {
                z4_0(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TAfterRest));
				z3_1();
                z5_0();
				y=1;
            } else
            if (!x1_0()) {
				z3_2();
				y=1;
			}
        break;
        case 1: //  
			if (x5_0()&&x3_0()) {
				y=0;
			} else
			if (x5_0()&&!x3_0()&&x1_0()) {
				z3_0();
				y=0;
			} else
			if (x2_0()) {				
				y=2;
			} else
			if (x3_1()) {
				DoNested(aA1.e2,&aA1);
				z1_1();
				z5_2();
				y=3;
			} else
			if (x3_2()) {
				DoNested(aA1.e2,&aA1);
				z1_2();
				z5_2();
				y=4;
			}
        break;
        case 2: //   
			DoNested(e, &aA2);
			if (aA2.y==0) {
				z4_0(0);
				z3_1();
				z2_1();
				z5_1();
				y=1;
			}
        break;
		case 3: // 
			DoNested(e, &aA1);
			if (aA1.y==0&&(x2_0()||(x5_0()&&x1_0()))) {
				z4_0(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUpBraking));
				y=1;
			} else
			if (aA1.y==0&&!x2_0()) {
				z1_1();
			}
		break;
        case 4: // 
			DoNested(e, &aA1);
			if (aA1.y==0&&(x2_0()||(x5_0()&&x1_0()))) {
				z4_0(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDownBraking));
				y=1;
			} else
			if (aA1.y==0&&!x2_0()) {
				z1_2();
			}
        break;
    }
}

void A0::WriteLog(CString s,int indent) //     s (indent - )
{
    if (!DoLog) return;
    ((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog+=AutoService::IndentSpaces(indent+BaseIndent)+s+"\r\n";
}

void A0::WriteLogOnStart(int y,int e,int indent) //      ,      e (indent - )
{
    if (!DoLog) return;
    CString str;
	CString s;
	if (e==e0) s="e0"; else
	if (e==e1) s="e1";
    str.Format(" A0    %d   %s",y,s);
    WriteLog(str,indent);
}

void A0::WriteLogOnStateChanged(int y,int y_old,int indent) //      ,      y_old  y (indent - )
{
    if (!DoLog) return;
    CString str;
    if (y==y_old) str.Format(" A0   %d",y);
        else str.Format(" A0    %d   %d",y_old,y);
    WriteLog(str,indent);
}

void A0::WriteLogOnFinish(int y,int indent) //      ,       y (indent - )
{
    if (!DoLog) return;
    CString str;
	str.Format(" A0     %d",y);
    WriteLog(str,indent);
}

///////////////////////////////////////////////////////////////
//  

// ,    

int A0::x1_0()
{
	int b=(floor==2);
	CString str;
	str.Format("x1_0:      () ? -  %d",b);
    WriteLog(str,3);
    return b;
}

// ,    

int A0::x2_0()
{
	StateValues st=i3_0();
	int b=(((st!=GOINGDOWN)&(calls.up[floor]!=0))|((st!=GOINGUP)&(calls.down[floor]!=0))|(calls.car[floor]!=0));
	CString str;
	str.Format("x2_0:       ? -  %d",b);
    WriteLog(str,3);
    return b;
}

int A0::x2_1()
{
	int b=(calls.newcalls==true);
	CString str;
	str.Format("x2_1:     (  )? -  %d",b);
    WriteLog(str,3);
    return b;
}

// ,    

int A0::x3_0()
{
	int b=(state==NEUTRAL);
	CString str;
	str.Format("x3_0:   - \"NEUTRAL\" -  %d",b);
    WriteLog(str,3);
    return b;
}

int A0::x3_1()
{
	int b=(state==GOINGUP);
	CString str;
	str.Format("x3_1:   - \"GOINGUP\" -  %d",b);
    WriteLog(str,3);
    return b;
}

int A0::x3_2()
{
	int b=(state==GOINGDOWN);
	CString str;
	str.Format("x3_1:   - \"GOINGDOWN\" -  %d",b);
    WriteLog(str,3);
    return b;
}

// ,   

int A0::x4_0()
{
	int b=(timer==0);
	CString str;
	str.Format("x4_0:  ? -  %d",b);
    WriteLog(str,3);
    return b;
}

// ,    

int A0::x5_0()
{
	int b=(inactivitytimer==0);
	CString str;
	str.Format("x5_0:   ? -  %d",b);
    WriteLog(str,3);
    return b;
}

///////////////////////////////////////////////////////////////
//  

//   

void A0::z1_0()
{
    WriteLog("z1_0:      2",3);
    floor=2;
}

void A0::z1_1()
{
    WriteLog("z1_1:      1",3);
    floor++;
}

void A0::z1_2()
{
    WriteLog("z1_2:      1",3);
    floor--;
}

//    

void A0::z2_0()
{
    WriteLog("z2_0:   ",3);
    for (int i=0; i<5; i++) {
        calls.car[i]=0;
        calls.up[i]=0;
        calls.down[i]=0;
    }
	calls.newcalls=false;
}

void A0::z2_1()
{
    WriteLog("z2_1:      ",3);
	calls.car[floor]=0;
	if (state!=GOINGDOWN) calls.up[floor]=0;
	if (state!=GOINGUP) calls.down[floor]=0;
}

//    

void A0::z3_0()
{
    WriteLog("z3_0:   \"NEUTRAL\"",3);
    state=NEUTRAL;
}

void A0::z3_1()
{
	WriteLog("z3_1:  ,   ",3);
	state=i3_0();
}

void A0::z3_2()
{
    WriteLog("z3_2:     () ",3);
	state=((int)floor>2?GOINGDOWN:GOINGUP);
	if ((int)floor==2) state=NEUTRAL;
}

//   

void A0::z4_0(unsigned n)
{
    CString str; str.Format("z4_0(%d):     %d",n,n); WriteLog(str,3);
	timer=n;
}

//    

void A0::z5_0()
{
    WriteLog("z5_0:   ",3);
	inactivitytimer=-1;
}

void A0::z5_1()
{
    WriteLog("z5_1:   ",3);
	inactivitytimer=TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TInactive);
}

void A0::z5_2()
{
    WriteLog("z5_2:   ,    ",3);
	SWITCH_LOG_OFF //   
	if (!x5_0()) z5_0();
	SWITCH_LOG_ON //  
}

///////////////////////////////////////////////////////////////
//  

// ,    

A0::StateValues A0::i3_0()
{
	int i;
	switch (state)
	{
		case GOINGUP:
			if (calls.up[floor]!=0) return GOINGUP;
			for (i=floor+1; i<=5; i++)
			{
				if (i==5) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==5)
			{
				bool r=false;
				for (i=0; i<=(int)floor-1; i++) r|=((calls.car[i]!=0)|(calls.up[i]!=0)|(calls.down[i]!=0));
				if (r) state=GOINGDOWN; else if (!x5_0()) state=NEUTRAL;
			}
		break;

		case GOINGDOWN:
			if (calls.down[floor]!=0) return GOINGDOWN;
			for (i=floor-1; i>=-1; i--)
			{
				if (i==-1) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==-1)
			{
				bool r=false;
				for (i=floor+1; i<=4; i++) r|=((calls.car[i]!=0)|(calls.up[i]!=0)|(calls.down[i]!=0));
				if (r) state=GOINGUP; else if (!x5_0()) state=NEUTRAL;
			}
		break;

		case NEUTRAL:
			if (calls.up[floor]!=0||calls.down[floor]!=0) return NEUTRAL;
			for (i=0; i<=5; i++)
			{
				if (i==5) break;
				if (calls.car[i]!=0 || calls.up[i]!=0 || calls.down[i]!=0) break;
			}
			if (i==5 || i==(int)floor) return NEUTRAL;
			state=((int)floor>i?GOINGDOWN:GOINGUP);
		break;
	}
	return state;
}
