#include "stdafx.h"
#include "../Lift.h"
#include "Automat.h"
#include "A1.h"
#include "A2.h"
#include "A0.h"
#include "math.h"

//    
const A1::e0=0;
const A1::e1=1;
const A1::e2=2;

///////////////////////////////////////////////////////////////
//   A1

void A1::Step(int e)
{
    switch (y)
    {
        case 0: //  
            if (e==e0) {
                z1_0();
			} else
            if (e==e2) {
                z3_0();
			} else
			if (Nest->y==3&&!x3_0()) {
				z1_1();
				y=1;
			} else
			if (Nest->y==3&&x3_0()) {
				z2_1();
				y=2;
			} else
			if (Nest->y==4&&!x3_0()) {
				z1_2();
				y=3;
			} else
			if (Nest->y==4&&x3_0()) {
				z2_2();
				y=4;
			}
        break;
        case 1: //    
			if (!x1_1()) {
				z1_1();
			} else
			if (x1_1()) {
				z2_1();
				y=2;
			}
		break;
        case 2: //  
			if (!x2_1()) {
				z2_1();
			} else
			if (x2_1()) {
				y=0;
			}
		break;
        case 3: //    
			if (!x1_2()) {
				z1_2();
			} else
			if (x1_2()) {
				z2_2();
				y=4;
			}
		break;
        case 4: //  
			if (!x2_2()) {
				z2_2();
			} else
			if (x2_2()) {
				y=0;
			}
		break;
    }
}

void A1::WriteLog(CString s,int indent) //     s (indent - )
{
    if (!DoLog) return;
    ((CLiftApp*)AfxGetApp())->m_LogDlg.m_sLog+=AutoService::IndentSpaces(indent+BaseIndent)+s+"\r\n";
}

void A1::WriteLogOnStart(int y,int e,int indent) //      ,      e (indent - )
{
    if (!DoLog) return;
    CString str;
	CString s;
	if (e==e0) s="e0"; else
	if (e==e1) s="e1"; else
	if (e==e2) s="e2";
    str.Format(" A1    %d   %s",y,s);
    WriteLog(str,indent);
}

void A1::WriteLogOnStateChanged(int y,int y_old,int indent) //      ,      y_old  y (indent - )
{
    if (!DoLog) return;
    CString str;
    if (y==y_old) str.Format(" A1   %d",y);
        else str.Format(" A1    %d   %d",y_old,y);
    WriteLog(str,indent);
}

void A1::WriteLogOnFinish(int y,int indent) //      ,       y (indent - )
{
    if (!DoLog) return;
    CString str;
	str.Format(" A1     %d",y);
    WriteLog(str,indent);
}

///////////////////////////////////////////////////////////////
//  

// ,     

int A1::x1_1()
{	         
	int b=(rope==5.0-((A0*)Nest)->floor-1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUp)+1));
	CString str;
	str.Format("x1_1:      ? -  %d",b);
    WriteLog(str,3);
    return b;
}

int A1::x1_2()
{
	int b=(rope==3.0-((A0*)Nest)->floor+1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDown)+1));
	CString str;
	str.Format("x1_2:      ? -  %d",b);
    WriteLog(str,3);
    return b;
}

int A1::x2_1()
{
	int b=(rope==4.0-((A0*)Nest)->floor);
	CString str;
	str.Format("x2_1:     ? -  %d",b);
    WriteLog(str,3);
    return b;
}

int A1::x2_2()
{
	int b=(rope==4.0-((A0*)Nest)->floor);
	CString str;
	str.Format("x2_2:     ? -  %d",b);
    WriteLog(str,3);
    return b;
}

// ,    

int A1::x3_0()
{
	int b=(accelerated==true);
	CString str;
	str.Format("x3_0:  ? -  %d",b);
    WriteLog(str,3);
    return b;
}

///////////////////////////////////////////////////////////////
//  

//     

void A1::z1_0()
{
    WriteLog("z1_0:  ,  2- ",3);
    rope=2.0;
}

void A1::z1_1()
{
    WriteLog("z1_1:        ",3);
	rope-=1.0/((TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUp)+1)*TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TStarting));
	if (floor(rope+1)-rope>1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUp)+1)) rope=5.0-((A0*)Nest)->floor-1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUp)+1);
}

void A1::z1_2()
{
    WriteLog("z1_2:        ",3);
	rope+=1.0/((TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDown)+1)*TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TStarting));
	if (rope-floor(rope)>1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDown)+1)) rope=3.0-((A0*)Nest)->floor+1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDown)+1);
}

void A1::z2_1()
{
    WriteLog("z2_1:      ",3);
	accelerated=true;
	rope-=1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TUp)+1);
	if (4.0-((A0*)Nest)->floor>rope) rope=4.0-((A0*)Nest)->floor;
}

void A1::z2_2()
{
    WriteLog("z2_1:      ",3);
	accelerated=true;
	rope+=1.0/(TO(((CLiftApp*)AfxGetApp())->m_TODlg.m_TDown)+1);
	if (4.0-((A0*)Nest)->floor<rope) rope=4.0-((A0*)Nest)->floor;
}

//    

void A1::z3_0()
{
    WriteLog("z3_0:   ",3);
	accelerated=false;
}
